package de.ibh.RandomArt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.ImageLoader;
import org.eclipse.swt.widgets.Display;

public class RACLI {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if(args.length < 2 || args.length > 4) {
			System.err.println("Usage: RACLI <width> <height> [seed] [filename.png]");
			System.exit(1);
		}
		
		final int width = new Integer(args[0]);
		final int height = new Integer(args[1]);
		final long seed = args.length >= 3 ?  args[2].hashCode() : System.currentTimeMillis() / 1000;
		final String fn = args.length >= 4 ?  args[3] : null;
		
		if(fn != null)
			System.err.println("Generating " + width + "x" + height + " image '" + fn + "'...");
		
		Display display = new Display();
		RAImage.setDefaultBounds(width, height);
		Image img = RAImage.create(seed, display);
		ImageLoader loader = new ImageLoader();
		loader.data = new ImageData[] {img.getImageData()};
		if(fn == null)
			loader.save(System.out, SWT.IMAGE_PNG);
		else
			loader.save(fn, SWT.IMAGE_PNG);
		
		img.dispose();
		
		if(fn != null)
			System.err.println("Done.");
	}

}
