package de.ibh.RandomArt;

import java.util.List;

public class RAOConstant extends AbstractRAOperatorA0 {
	protected double c[]; 
	
	public RAOConstant(RAPRNG prng) {
		super(prng);
	}

	@Override
	public void init(List<AbstractRAOperator> ops) {
		super.init(ops);

		double f1 = prng.uniform(0, 1) < 0.5 ? 1.0 : -1.0;
		double f2 = prng.uniform(0, 1) < 0.5 ? 1.0 : -1.0;
		double f3 = prng.uniform(0, 1) < 0.5 ? 1.0 : -1.0;

		c = new double[] {prng.uniform(0.25,1)*f1, prng.uniform(0.25,1)*f2, prng.uniform(0.25,1)*f3};
	}
	
	@Override
	public double[] eval(final double x, final double y) {
		return c;
	}
}
