package de.ibh.RandomArt;

import java.util.List;

public class RAOLevel extends AbstractRAOperatorA3 {
	protected double thresold;
	
	public RAOLevel(RAPRNG prng) {
		super(prng);
	}

	@Override
	public void init(List<AbstractRAOperator> ops) {
		super.init(ops);

		thresold = prng.uniform(-1, 1);
	}
	
	@Override
	public double[] eval(final double x, final double y) {
		double level[] = ops.get(0).eval(x, y);
		double rgb1[] = ops.get(1).eval(x, y);
		double rgb2[] = ops.get(2).eval(x, y);

		RAUtilities.checkRGB(level);
		RAUtilities.checkRGB(rgb1);
		RAUtilities.checkRGB(rgb2);
		
		return new double[] {
				level[0] < thresold ? rgb1[0] : rgb2[0],
				level[1] < thresold ? rgb1[1] : rgb2[1],
				level[2] < thresold ? rgb1[2] : rgb2[2],
		};
	}
}
