/**
 * 
 */
package de.ibh.RandomArt;

import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;

import de.ibh.RandomArt.RAImage;

/**
 * @author liske
 *
 */

public class RATest {
	private Shell sShell;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new RATest();
		System.exit(0);
	}
	
	public RATest() {
		Display display = Display.getDefault();

		createSShell();
		sShell.open();

		while (!sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}
	
	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		sShell = new Shell();

        sShell.setText("Random Art Testbed");
		sShell.setLayout(new GridLayout());
		
		final ScrolledComposite sc = new ScrolledComposite(sShell, SWT.V_SCROLL);		
		sc.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		
		Composite c = new Composite(sc, SWT.NONE | SWT.BORDER);
		c.setLayout(new GridLayout(15, true));

		new FillImages(c).start();

		sc.setContent(c);
	    sc.setExpandHorizontal(true);
	    sc.setExpandVertical(true);
	    sc.setMinSize(c.computeSize(SWT.DEFAULT, SWT.DEFAULT));
	}

	class FillImages extends Thread {
		private Composite c;
		private GridData gd;
		
        public FillImages(final Composite c) {
            setName("FillImageThread");
    	    
            this.c = c;
            
            gd = new GridData(SWT.FILL, SWT.FILL, true, true);
            gd.minimumWidth = RAImage.getDefaultWidth();
            gd.widthHint = RAImage.getDefaultWidth();
            gd.minimumHeight = RAImage.getDefaultHeight();
            gd.heightHint = RAImage.getDefaultHeight();
        }
        
        public void run() {
            c.getDisplay().asyncExec(new Runnable() {
				@Override
				public void run() {
	            	for(int i = 0; i < 120; i++) {
	            		final String seed = "TEST" + i;
	            		final String tt = "seed: " + seed.hashCode() + "\n\n" + RAImage.printExprTree(seed.hashCode());

	            		final Group g = new Group(c, SWT.SHADOW_ETCHED_IN);
	            		g.setText(seed);
	            		g.setLayout(new GridLayout());
	            		g.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true));
	            		g.setToolTipText(tt);

	            		final Image img = RAImage.create(seed, g.getDisplay());
	            		Canvas canvas = new Canvas(g, SWT.NONE);
	            		canvas.addPaintListener(new PaintListener() {
	            			public void paintControl(PaintEvent e) {
	            				e.gc.drawImage(img, 0, 0);
	            			}
	            		});
	            		canvas.setLayoutData(gd);
	            		canvas.setToolTipText(tt);

	            		c.pack(true);
	            		c.update();
	            	}
				}
            });
       	}
   	}
}
