package de.ibh.StrongRoom.Client.Lucene;

import java.io.ByteArrayInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.apache.lucene.store.IndexInput;

import de.ibh.StrongRoom.DB.DBConn;
import de.ibh.StrongRoom.DB.LuceneStore;
import de.ibh.StrongRoom.Exception.SRGenericCryptoEngineException;
import de.ibh.StrongRoom.Exception.SRSecretKeyNotFoundException;

public class SRIndexInput extends IndexInput {
	ByteArrayInputStream is;
	int pos;
	int len;
	LuceneStore file;
	DBConn db;
	SRCrypto src;
	
	public SRIndexInput(final LuceneStore file, final DBConn db, final SRCrypto src) throws FileNotFoundException, SRSecretKeyNotFoundException, SRGenericCryptoEngineException {
		this.file = file;
		this.db = db;
		this.src = src;

		pos = 0;
		final byte[] ba = src.decryptInput(db.getLuceneStoreContent(file));

		if(ba == null)
			throw new FileNotFoundException(file.toString());

		is = new ByteArrayInputStream(ba);


		len = (int) db.getLuceneStoreSize(file);

		System.err.println("opening: " + file.getName() + "("+is.available()+"/" + len + "/" + db.getLuceneStoreSize(file) + ")");
	}

	@Override
	public void close() throws IOException {
	}

	@Override
	public long getFilePointer() {
		return pos;
	}

	@Override
	public long length() {
		return len;
	}

	@Override
	public byte readByte() throws IOException {
		return (byte) is.read();
	}

	@Override
	public void readBytes(byte[] b, int off, int l) throws IOException {
		is.read(b, off, l);
	}

	@Override
	public void seek(long p) throws IOException {
		is.reset();
		is.skip(p);
	}

}
