package de.ibh.StrongRoom.Crypto;

import javax.crypto.*;
import javax.crypto.spec.*;

/**
 * Test to make sure the unrestricted policy files are installed.
 */
public class JCEPolicyTest {
    @SuppressWarnings("finally")
	static public int getMaxBits() {
    	// 56bit should always work...
    	int max = 56;

    	try {
    		final byte[] data = { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07 };

    		// 64bit secret key
    		final SecretKey key64 = new SecretKeySpec(
        		new byte[] { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07 }, "Blowfish"
    		);
    		Cipher c = Cipher.getInstance("Blowfish/ECB/NoPadding");
			c.init(Cipher.ENCRYPT_MODE, key64);
			c.doFinal(data);
			max = 64;

			// 192bit secret key
			final SecretKey key192 = new SecretKeySpec(new byte[] {
					0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
					0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
					0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17 
			}, "Blowfish");

			c.init(Cipher.ENCRYPT_MODE, key192);
			c.doFinal(data);
			max = 192;
    	}
    	finally {
    		return max;
    	}
   	}
}

