package de.ibh.StrongRoom.DB;

import java.util.HashMap;
import java.util.Map;

import de.ibh.StrongRoom.Crypto.CryptoBackend.ECryptoPGP_KeyType;

public class UserRole implements ISignedRow {
    private String userKeyFPR;
    private long roleID;
    private String rKeyFPR;
    private String signSKey;
    private String signRKey;
    
    UserRole(final String userKeyFPR, final long roleID, final String rKeyFPR, final String signSKey, final String signRKey) {
        this.userKeyFPR = userKeyFPR;
        this.roleID = roleID;
        this.rKeyFPR = rKeyFPR;
        this.signSKey = signSKey;
        this.signRKey = signRKey;
    }
    
    
    public String getUserKeyFPR() {
        return userKeyFPR;
    }
    
    
    public long getRoleID() {
        return roleID;
    }

	@Override
	public String[] getSignStrings() {
		return new String[] {
				userKeyFPR,
				Long.toString(roleID),
				rKeyFPR
		};
	}
 
	public Map<ECryptoPGP_KeyType, String> getSignKeyMap() {
		Map<ECryptoPGP_KeyType, String> m = new HashMap<ECryptoPGP_KeyType, String>();

		m.put(ECryptoPGP_KeyType.ROLE_KEY, signRKey);
		m.put(ECryptoPGP_KeyType.SIGNING_KEY, signSKey);

		return m;
	}


	@Override
	public void setSigningData(ECryptoPGP_KeyType kt, String sig) {
		if(kt == ECryptoPGP_KeyType.ROLE_KEY)
			signRKey = sig;
		else if(kt == ECryptoPGP_KeyType.SIGNING_KEY)
			signSKey = sig;
		else
			throw new IllegalArgumentException();
	}
 }
