package de.ibh.StrongRoom.Log;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.Writer;

import org.apache.log4j.Appender;
import org.apache.log4j.Logger;

public class DebugMessage {
    private Logger               logger   =  Logger.getLogger(DebugMessage.class);
    private boolean              enabled  = false;
    static private DebugMessage  debugmsg = null;    
    
    
    static public DebugMessage getInstance() {
        if (debugmsg != null)
            return debugmsg;

        debugmsg = new DebugMessage();
        
        return debugmsg;
    }
    
    public void debugEnable(boolean enable) {
        this.enabled = enable;
    }
    
    
    public void addAppender(Appender appender) {
        if(logger != null) logger.addAppender(appender);
    }
    
    
    public void info(String msg) {
        logger.info(msg);
    }

    public void info(Exception e) {
    	logger.info("Exception " + e.getClass().getCanonicalName() + ": " + e.getMessage());
    	
    	Writer writer = new StringWriter();
    	PrintWriter printWriter = new PrintWriter(writer);
    	e.printStackTrace(printWriter);
    	logger.info("StrackTrace: " + writer.toString());
    }
    
    public void debug(String msg) {
        if(enabled == true && logger != null) {
            logger.debug(msg);
        }
    }

    public void debug(Exception e) {
    	logger.debug("Exception " + e.getClass().getCanonicalName() + ": " + e.getMessage());
    	
    	Writer writer = new StringWriter();
    	PrintWriter printWriter = new PrintWriter(writer);
    	e.printStackTrace(printWriter);
    	logger.debug("StrackTrace: " + writer.toString());
    }
}