//---------------------------------------------------------------------------
// Freely available from Media Art Online (http://www.media-art-online.org/).
// Copyright (C) 2003, 2004 Media Art Online (cafe@media-art-online.org)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// PROJECT: PGP/GnuPG Applications
// MODULE:  GnuPG support
// FILE:    GnuPGName.java
//
// DESCRIPTION:
//
// REVISION HISTORY:
//  Name      Date        Description
//  ----      ----------  -----------
//  ks91      2003/02/16  initial version
//
// $Id: //depot/scm/main/java/org/media_art_online/gnupg/GnuPGName.java#7 $
// $DateTime: 2005/09/05 01:48:50 $
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Package
//---------------------------------------------------------------------------
package org.media_art_online.gnupg;

//---------------------------------------------------------------------------
// Import
//---------------------------------------------------------------------------
import java.util.Vector;

public class GnuPGName {

	public GnuPGName(String sName, String sID) {

		int idx;
		int i;

		while ((i = sName.indexOf(S_DIV_INFO)) >= 0) {
			sName = sName.substring(0, i) + sName.substring(i + 1);
		}

		if ((i = sName.indexOf(S_DIV_BEGIN_EMAIL)) >= 0) {
			_sReal = sName.substring(0, i).trim();

			if ((i = sName.indexOf(S_DIV_END_EMAIL, idx = i + 1)) >= 0) {
				_sEmail = sName.substring(idx, i);
			}

		} else {
			_sReal = "";
			_sEmail = sName;
		}

		_sID = sID;

		_vectorSigs = null;
	}

	public GnuPGName(String sRealName, String sEmailName, String sID) {

		_sReal  = sRealName;
		_sEmail = sEmailName;
		_sID    = sID;

		_vectorSigs = null;
	}

	public boolean equals(GnuPGName name) {
		return (_sEmail.length() > 0 && _sEmail.equals(name._sEmail));
	}

	public String getEmailName() {
		return (_sEmail);
	}

	public String getID() {
		return (_sID);
	}

	public String getRealName() {
		return (_sReal);
	}

	public Vector<String> getSignatures() {
		return (_vectorSigs);
	}

	public boolean identifies(GnuPGName name) {
		return (_sID.equals(name._sID));
	}

	public void setID(String sID) {
		_sID = sID;
	}

	public void setSignatures(Vector<String> vectorSigs) {
		if (vectorSigs != null && vectorSigs.size() > 0) {
			_vectorSigs = vectorSigs;
		}
	}

	public String toString() {
		return (_sReal.equals("")
		 ? _sEmail
		 : _sReal + " " + S_DIV_BEGIN_EMAIL + _sEmail + S_DIV_END_EMAIL);
	}

	private String _sEmail;
	private String _sID;
	private String _sReal;

	private Vector<String> _vectorSigs;

	private static final String S_DIV_BEGIN_EMAIL = "<";
	private static final String S_DIV_END_EMAIL   = ">";
	private static final String S_DIV_INFO        = ":";
};

// GnuPGName.java
