//---------------------------------------------------------------------------
// Freely available from Media Art Online (http://www.media-art-online.org/).
// Copyright (C) 2004 Media Art Online (cafe@media-art-online.org)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// PROJECT: PGP/GnuPG Applications
// MODULE:  GnuPG support
// FILE:    GnuPGPhoto.java
//
// DESCRIPTION:
//
// REVISION HISTORY:
//  Name      Date        Description
//  ----      ----------  -----------
//  ks91      2004/09/01  initial version
//
// $Id: //depot/scm/main/java/org/media_art_online/gnupg/GnuPGPhoto.java#6 $
// $DateTime: 2006/09/15 07:34:27 $
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Package
//---------------------------------------------------------------------------
package org.media_art_online.gnupg;

//---------------------------------------------------------------------------
// Import
//---------------------------------------------------------------------------
import java.io.*;
import javax.swing.*;

public class GnuPGPhoto extends GnuPGName {

	public static final String S_EXT_JPEG = ".jpg";

	public GnuPGPhoto(String sID) {
		super("", "", sID);

		_icon = null;
	}

	public static void clearIcons(GnuPGUser user, String sDirPhoto) {

		File[] aoFiles = (new File(sDirPhoto)).listFiles();
		String sKey = user.getPrimaryKey().getID();

		for (int i = 0; i < aoFiles.length; i++) {

			if (aoFiles[i].getName().startsWith(sKey)) {
				aoFiles[i].delete();
			}
		}
	}

	public void createIcon(GnuPGUser user, String sDirPhoto, int index) {

		File file = getPhotoFile(user, sDirPhoto, index);

		if (file.exists()) {
			_icon = new ImageIcon(file.getPath());
		}
	}

	public ImageIcon getIcon() {
		return ((ImageIcon)_icon);
	}

	public File getPhotoFile(GnuPGUser user, String sDirPhoto, int index) {
		return (new File(_sPathPhoto = sDirPhoto + File.separator
		 + user.getPrimaryKey().getID() + "-"
		 + (_index = index) + S_EXT_JPEG));
	}

	public String getPhotoPath() {
		return (_sPathPhoto);
	}

	public ImageIcon getScaledIcon(int width, int height) {

		ImageIcon icon = null;

		if (_icon != null) {
			icon = new ImageIcon(
			 ((ImageIcon)_icon).getImage().getScaledInstance(width, height,
			 java.awt.Image.SCALE_DEFAULT));
		}

		return (icon);
	}

	public String toString() {
		return (String.valueOf(_index));
	}

//===========================================================================
// BARRIER: Anything below is not open to other files.
//===========================================================================

	private Object _icon;

	private String _sPathPhoto;

	private int _index;
};

// GnuPGPhoto.java
